.u-boot_unpack: $(SRC)/u-boot
	cp -ar $< u-boot
	touch $@

.u-boot_configure: .u-boot_unpack
	cd u-boot && $(MAKE) $(UBOOT_CONFIG)_defconfig
	touch $@

.u-boot_compile: .u-boot_configure
	cd u-boot && $(MAKE) $(MAKEOPTS)
	touch $@

$(SRC)/$(LINUX_SRC):
	wget -O$(SRC)/$(LINUX_SRC) "$(LINUX_SRC_URI)"

.linux_unpack: $(SRC)/$(LINUX_SRC)
	tar xf $(SRC)/$(LINUX_SRC)
	touch $@

.linux_configure: .linux_unpack
	cd $(LINUX_DIR) && $(MAKE) $(LINUX_CONFIG)_defconfig
	touch $@

.linux_compile: .linux_configure
	cd $(LINUX_DIR) && $(MAKE) $(MAKEOPTS) zImage dtbs
	touch $@

.linux_modules: .linux_configure
	cd $(LINUX_DIR) && $(MAKE) $(MAKEOPTS) modules
	touch $@

.linux_modules_install:  .linux_modules
	rm -rf $(PWD)/modules_install
	mkdir -p $(PWD)/modules_install
	mkdir -p $(LINUX_MODULES_INSTALL)
	INSTALL_MOD_PATH=$(PWD)/modules_install $(MAKE) -C $(LINUX_DIR) $(MAKEOPTS) modules_install
	touch $@



boot:  .linux_compile $(BOOTLOADER_FILES)
	rm -rf boot
	mkdir boot
	cp -v $(BOOTLOADER_FILES) boot/
	cp -v $(LINUX_DIR)/arch/arm/boot/zImage boot/$(KERNEL_TARGET)
	cp -v $(LINUX_DIR)/arch/arm/boot/dts/*dtb boot/
	touch $@

info:
	@echo LINUX_SRC_URI $(LINUX_SRC_URI)
	@echo LINUX_SRC $(LINUX_SRC)
	@echo LINUX_DIR $(LINUX_DIR)
	@echo LINUX_SRC_URI $(LINUX_SRC_URI)



.busybox_install:
	rm -rf busybox_install
	$(MAKE) $(MAKEOPTS) -C $(BUSYBOX_DIR) install
	rsync $(BUSYBOX_DIR)/_install/ busybox_install/
	touch $@


rootfs: $(foreach pkg, $(PACKAGES), .$(pkg)_install)
	rm -rf rootfs
	mkdir rootfs
	for o in $(PKG_OVERLAYS) $(OVERLAYS) ; do \
		rsync -av $$o/ rootfs/ ; \
	done

#flash:
#	rsync -a --delete boot/ /..../boot/
#	rsync -a --delete rootfs /..../rootfs/
